::xo::library doc {
    XOSCORM - form fields

    @creation-date 2010
    @author Michael Aram
}

::xo::library require -package xowiki form-field-procs

namespace eval ::xowiki {}
namespace eval ::xowiki::formfield {

  ###########################################################
  #
  # ::xowiki::formfield::scorm_package
  #
  ###########################################################

  Class scorm_package -superclass import_archive

  ###########################################################
  #
  # ::xowiki::formfield::scorm_organization
  #
  ###########################################################

  Class scorm_organization -superclass select -parameter {
    {multiple "false"}
  }

  scorm_organization instproc initialize {} {
    next
    my compute_options
  }

  scorm_organization instproc has_manifest {} {
      my instvar object
      if {[$object istype ::xowiki::FormPage] && [$object has_manifest]} {
        return true
      }
      return false
  }

  scorm_organization instproc get_default_or_implicit_organization {} {
      my instvar object
      if {[my has_manifest]} {
        set manifest [$object get_manifest]
        set org [$manifest get_default_or_implicit_organization]
        return $org
      }
      return ""
  }

  scorm_organization instproc pretty_value {v} {
    if {$v eq ""} {
      # The organization wasnt manually selected by the instructor,
      # lets display the default.
      set org [my get_default_or_implicit_organization]
      if {$org ne ""} {
        return [$org title]
      }
    } else {
      return [next]
    }
  }

  scorm_organization instproc compute_options {} {
    my instvar object
    set options [list]
    if {[my has_manifest]} {
      set manifest [$object get_manifest]
      set options [${manifest}::organizations as_widget_options]
    }
    my set options $options
  }

  scorm_organization instproc render_input {} {
    my compute_options
    if {[my value] eq "" && [my has_manifest]} {
      my value [[my get_default_or_implicit_organization] identifier]
    }
    next
  }
}

::xo::library source_dependent 
