::xo::library require -package xowiki xowiki-procs
# TODO Move this to a mixin, e.g. ::xowiki::ScormPackage

namespace eval ::xowiki {

  ::xowiki::FormPage ad_instproc scorm-api {} {} {
    set api_function [::xo::cc form_parameter api_function]
    if {[::xotcl::Object isobject ::xo::scorm::$api_function]} {
      ::xo::scorm::$api_function response
    } else {
      set log "SCORM API function: \"$api_function\" does not exist."
      ns_log warn $msg
      ns_return 200 text/plain $msg
    }
  }

  ::xowiki::FormPage ad_instproc has_manifest {} {} {
    my instvar package_id
    if {[my isobject [self]::manifest]} {
      return true
    }
    set manifest_item_id [$package_id lookup -name file:imsmanifest.xml -parent_id [my item_id]]
    if {$manifest_item_id ne 0} {
      return true
    }
    return false
  }

  ::xowiki::FormPage ad_instproc get_manifest {} {
      Returns a fully-built manifest object based upon the xml
      inside the imsmanifest.xml file that lies in the current instance
      TODO Caching
    } {
    my instvar package_id
    if {![my has_manifest]} {
      return ""
    }
    if {[my isobject [self]::manifest]} {
      return [self]::manifest
    }
    set manifest_item_id [$package_id lookup -name file:imsmanifest.xml -parent_id [my item_id]]
    if {$manifest_item_id ne 0} {
      set page [::xo::db::CrClass get_instance_from_db -item_id $manifest_item_id]
      if {$page ne "" && [$page istype ::xowiki::File]} {
        set m [::xo::scorm::Manifest create [self]::manifest -location [$page full_file_name]]
        $m set course [self]
        return $m
      }
    }
    return ""
  }
}
