::xo::library doc {
    XOSCORM Includelets

    @creation-date 2010-06
    @author Michael Aram
}

::xo::library require -package xowiki includelet-procs

namespace eval ::xowiki::includelet {

#  ::xowiki::IncludeletClass create folders \
#    -superclass ::xolrn::includelet::folders

#  ::xowiki::IncludeletClass create child_resources \
#    -superclass ::xolrn::includelet::child_resources

  ::xowiki::IncludeletClass create scorm-player \
      -superclass ::xowiki::Includelet \
      -parameter {
        {parameter_declaration {
           {-title ""}
           {-url ""}
           {-width "100%"}
           {-height "600"}
           {-frameid "xoscorm-player"}
        }}
      }

  scorm-player instproc render {} {
    my get_parameters
    if {[$package_id package_key] ne "xoscorm"} {
      $package_id mixin ::xo::scorm::Package
    }
    my set config(page) [my set __including_page]
    my set config(course_id) [[my set config(page)] item_id]
    my set config(package_id) $package_id
    my set config(url) [ns_urldecode $url]
    my instvar config

    ::xo::scorm::session set_current_course_id -course_id $config(course_id)

    if {[$config(page) has_manifest]} {
      my get_manifest
      my get_organization_to_show
      my get_url_to_launch
      my create_navigation_tree
      my setup_api
      append content [my render_api]
      append content "<iframe id='$frameid'
          name='$frameid'
          src='$config(url)'
          width='[my get_width]'
          height='[my get_height]'>
          </iframe>"
      append content [my set auto_height_js]
      append content [my set auto_width_js]
      if {[acs_user::site_wide_admin_p]} {
        append content [my render_logger]
      }
    } else {
      set content "#xoscorm.package_manifest_not_found#"
    }
    return $content
  }

  scorm-player instproc render_api {} {
    my instvar config

    return [subst "<script>
      /*
       * Client-side API
       *
       * This code provides a minimal API Adapter. It routes every call directly to the server.
       * As there are much more sophisticated implementations (that do client side caching etc...),
       * this code should be enhanced/replaced in future.
       */

      var API = {};

      API.syncRequest = function(pars) {
          pars = 'xoscorm_course_id=$config(course_id)&xoscorm_sco_id=$config(sco_id)&' + pars;
          var answer;
          $.ajax({
            type: 'POST',
            async: false,
            url: '?m=scorm-api',
            data: pars,
            success: function(msg) {
              answer = msg;
              YAHOO.log(pars + ' --> ' + msg);
            },
            error: function(msg) {
              YAHOO.log('Error contacting LMS: ' + pars + msg, 'warn');
            }
          });
          return answer;
      }

      /*
       * Mandatory API Functions
       */

      API.LMSInitialize       = function(parameter) {
          return this.syncRequest( 'api_function=LMSInitialize'+ '&parameter='+ encodeURIComponent(parameter) );
      }

      API.LMSFinish           = function(parameter) {
          return this.syncRequest( 'api_function=LMSFinish'+ '&parameter='+ encodeURIComponent(parameter) );
      }

      API.LMSGetValue         = function(element) {
          return this.syncRequest( 'api_function=LMSGetValue'+ '&element='+ encodeURIComponent(element) );
      }

      API.LMSSetValue         = function(element,value) {
          return this.syncRequest( 'api_function=LMSSetValue'+ '&value='+ encodeURIComponent(value)   + '&element='   + encodeURIComponent(element) );
      }

      API.LMSCommit           = function(parameter) {
          return this.syncRequest( 'api_function=LMSCommit'+ '&parameter='+ encodeURIComponent(parameter) );
      }

      API.LMSGetLastError     = function() {
          return this.syncRequest( 'api_function=LMSGetLastError');
      }

      API.LMSGetErrorString   = function(errornumber) {
          /* return this.syncRequest( 'api_function=LMSGetErrorString'+'&errornumber='+ encodeURIComponent(errornumber) ); */
          switch (errornumber) {
              case 0:   return 'No Error';
              case 101: return 'General Exception';
              case 201: return 'Invalid argument error';
              case 202: return 'Element cannot have children';
              case 203: return 'Element not an array - cannot have count';
              case 301: return 'Not initialized';
              case 401: return 'Not implemented error';
              case 402: return 'Invalid set value, element is a keyword';
              case 403: return 'Element is read only';
              case 404: return 'Element is write only';
              case 405: return 'Incorrect Data Type';
              default:  return this.syncRequest( 'api_function=LMSGetErrorString'+'&errornumber='+ encodeURIComponent(errornumber) );
          }
      }

      API.LMSGetDiagnostic    = function(errornumber) {
          /* return this.syncRequest( 'api_function=LMSGetDiagnostic'+'&errornumber='+ encodeURIComponent(errornumber) ); */
          switch (errornumber) {
              case 0:   return 'No vendor specific information provided';
              case 101: return 'No vendor specific information provided';
              case 201: return 'No vendor specific information provided';
              case 202: return 'No vendor specific information provided';
              case 203: return 'No vendor specific information provided';
              case 301: return 'No vendor specific information provided';
              case 401: return 'No vendor specific information provided';
              case 402: return 'No vendor specific information provided';
              case 403: return 'No vendor specific information provided';
              case 404: return 'No vendor specific information provided';
              case 405: return 'No vendor specific information provided';
              default:  return this.syncRequest( 'api_function=LMSGetDiagnostic'+'&errornumber='+ encodeURIComponent(errornumber) );
          }
      }
      </script>
    " ]
  }

  scorm-player instproc render_logger {} {
    ::template::head::add_css -href "http://yui.yahooapis.com/2.8.1/build/logger/assets/skins/sam/logger.css"
    ::template::head::add_javascript -order F -src "http://yui.yahooapis.com/2.8.1/build/logger/logger-min.js"
    return [subst {<div id="xoscorm-api-logger"></div>
      <script>
        var myConfigs = {
          width: "600px",
          height: "200px",
          newestOnTop: true,
          verboseOutput: false,
          footerEnabled: false
        };
        var myLogReader = new YAHOO.widget.LogReader("xoscorm-api-logger", myConfigs);
      </script>}]
  }

  scorm-player instproc get_width {} {
    my get_parameters
    my instvar config
    set local_width [$config(page) property player_width]
    if {![string is integer -strict $local_width]} {
      my set auto_width_js [subst {<script>
          \$("#$frameid").load(function () {
            var calculatedFrameWidth = \$("#$frameid").width();
            var calculatedInnerFrameWidth = \$("#$frameid").contents().find("html").width();
            if (calculatedInnerFrameWidth > calculatedFrameWidth) {
              \$("#$frameid").height(calculatedFrameWidth + 25);
            }
          });
        </script>}]
      return $width
    }
    my set auto_width_js ""
    return $local_width
  }

  scorm-player instproc get_height {} {
    my get_parameters
    my instvar config
    set local_height [$config(page) property player_height]
    if {![string is integer -strict $local_height]} {
      my set auto_height_js [subst {<script>
          \$("#$frameid").load(function () {
            var defaultHeight = $height;
            var calculatedInnerFrameHeight = \$("#$frameid").contents().find("html").height();
            if (calculatedInnerFrameHeight > defaultHeight) {
              \$("#$frameid").height(calculatedInnerFrameHeight + 25);
            }
          });
        </script>}]
      return $height
    }
    my set auto_height_js ""
    return $local_height
  }

  scorm-player instproc setup_api {} {
    #::template::head::add_javascript -order A  -src  "/resources/xoscorm/1.2/prototype.js"
    ::template::head::add_javascript -order A  -src  "/resources/xoscorm/jquery-1.4.2.js"
    #::template::head::add_javascript -order C  -src  "/resources/xoscorm/1.2/scorm_api.js"
    ::template::head::add_javascript -order C  -src  "/resources/ajaxhelper/yui/utilities/utilities.js"
    #::template::head::add_javascript -order C  -src  "/resources/ajaxhelper/yui/container/container-min.js"
    #::template::head::add_javascript -order D  -src  "/resources/ajaxhelper/yui/resize/resize-min.js"
    ::template::head::add_css -order E -href  "/resources/xoscorm/xoscorm.css"
  }

  scorm-player instproc get_manifest {} {
    my instvar config
    set config(manifest) [$config(page) get_manifest]
  }


  scorm-player instproc get_organization_to_show {} {
    my instvar config
    set org_id [$config(page) property organization]
    if {$org_id eq ""} {
        set org [$config(manifest) get_default_or_implicit_organization]
    } else {
        set org [$config(manifest) get_organization -identifier $org_id]
    }
    set config(organization) $org
  }

  scorm-player instproc get_url_to_launch {} {
    my instvar config
    if {$config(url) eq ""} {
      set launch_url ""
      # We have no url given - where should we start?
      set last_sco_id [::xo::scorm::session get_current_sco_id]
      if {$last_sco_id ne ""} {
        # Go to the users "current sco"
        set config(item_to_launch) [$config(manifest) get_element_by_identifier $last_sco_id]
        if {$config(item_to_launch) ne ""} {
          set launch_url [::xowiki::utility urlencode [$config(item_to_launch) href]]
        } else {
          my log "couldnt determine url for sco"
        }
      }
      if {$launch_url eq ""} {
        # We didnt find the current sco - got to the default entry
        set config(item_to_launch) [$config(organization) get_default_entry_item]
        set launch_url [$config(item_to_launch) href]
      }
      if {$launch_url ne ""} {
        set config(sco_id) [$config(item_to_launch) identifier]
        set redirect_url [export_vars -base [::xo::cc url] \
            [list \
            [list url $launch_url] \
            [list xoscorm_sco_id $config(sco_id)] \
            [list xoscorm_course_id $config(course_id)] ] \
        ]
        $config(package_id) returnredirect $redirect_url
      }
    } else {
      set sco_id [::xo::cc query_parameter xoscorm_sco_id]
      set config(item_to_launch) [$config(manifest) get_element_by_identifier $sco_id]
      #my log "\n\nThe Player launches: [::xo::db::CrClass get_name -item_id $config(course_id)]\n\n"
      my set config(sco_id) [$config(item_to_launch) identifier]
      ::xo::scorm::session launch -course_id $config(course_id) -sco_id $config(sco_id)
    }
  }

  scorm-player instproc create_navigation_tree {} {
    my instvar config
    set tree_structure [my convert_organization_to_treenode $config(organization)]
    if {[info command ::__xowiki__MenuBar] ne ""} {
      ::__xowiki__MenuBar set submenu_treenode(scorm) $tree_structure
    }
  }

  scorm-player instproc convert_organization_to_treenode {scorm_organization} {
    set label [$scorm_organization title]
    set node [::xowiki::TreeNode new \
                     -label $label \
                     -label_class "scorm-organization" \
                     -highlight 0 \
                     -expanded 1 \
                     -open_requests 1]
    foreach c [$scorm_organization children_of_type Item] {
      $node add [my convert_item_to_treenode $c]
    }
    return $node
  }

  scorm-player instproc convert_item_to_treenode {scorm_item} {
    my instvar config
    set href ""
    set label [$scorm_item title]
    set scorm_item_identifier [$scorm_item identifier]
    #set scorm_item_href [ns_urlencode [$scorm_item href]]
    set scorm_item_href [::xowiki::utility urlencode [$scorm_item href]]
    if {$scorm_item_href ne ""} {
      # # We add the course id, if we have an url (not all items have links)
      set course [[$scorm_item get_including_manifest] set course]
      #set course_id [$course item_id]
      #set course_href [$course pretty_link]
      # We now use relative links in the form
      # course_cr_name?url=...&xoscorm_sco_id=...
      # to avoid problems with links.
      set href [export_vars -base [$course name] {
        {xoscorm_sco_id $scorm_item_identifier}
        {url $scorm_item_href}
      }]
    }

    set session_fp [::xo::scorm::session get_sco_session_data -sco_id $scorm_item_identifier -course_id $config(course_id)]

    set highlight 0
    if {$scorm_item_identifier eq [::xo::scorm::session get_current_sco_id]} {
      set highlight 1
    }
    set fp_pn [::xo::scorm::data_model::cmi::core::lesson_status formpage_property_name]
    # If we have no href for the treenode, we most likely are at an "wrapper item"
    # these items would remain "not attempted", even if all subitems have been
    # attempted. So, for now, we just display lesson-status indicators for
    # "launchable" items and just display a "generic node icon" for the others
    set node_label_default_css_class [expr {$href eq "" ? "xoscorm_unknown" : "not-attempted"}]
    set node_label_css_class lesson-status-[$session_fp get_property \
        -name $fp_pn -default $node_label_default_css_class]

    set node [::xowiki::TreeNode new \
                     -href $href \
                     -label "$label" \
                     -label_class $node_label_css_class \
                     -highlight $highlight \
                     -expanded 1 \
                     -open_requests 1]
    foreach c [$scorm_item children_of_type Item] {
      $node add [my convert_item_to_treenode $c]
    }
    return $node
  }

}
