::xo::library doc {
  XOWiki specific functionality for the generic SCORM 
  objects (item, manifest, org,...)
}

namespace eval ::xo {}
namespace eval ::xo::scorm {

  Class OrganizationMixin

  ::ims::cp::Organization instmixin add ::xo::scorm::OrganizationMixin

  OrganizationMixin instproc decorate_page_order {} {
      set prefix ""
      set count 1
      foreach item [my children_of_type Item] {
          $item decorate_page_order $prefix $count
          incr count
      }
  }

  OrganizationMixin instproc generate_category {-cat_tree_id} {
      set org_cat_id [category::add -tree_id $cat_tree_id -parent_id "" -name "[my title]"]
      foreach item [my children_of_type Item] {
          $item generate_category -cat_tree_id "$cat_tree_id" -parent_id "$org_cat_id"
      }
  }


  Class ItemMixin

  ::ims::cp::Item instmixin add ::xo::scorm::ItemMixin

  ItemMixin instproc decorate_page_order {prefix count} {
      my set __page_order $prefix$count
      set subcount 1
      foreach item [my children_of_type Item] {
          $item decorate_page_order [my set __page_order]. $subcount
          incr subcount
      }
  }

  ItemMixin instproc generate_category {-parent_id -cat_tree_id} {
      my set __item_cat_id [category::add -tree_id $cat_tree_id -parent_id $parent_id -name "[my title]"]
      foreach item [my children_of_type Item] {
          $item generate_category -cat_tree_id "$cat_tree_id" -parent_id "[my set __item_cat_id]"
          my log "$item generate_category -cat_tree_id $cat_tree_id -parent_id [my set __item_cat_id]"

      }
  }

  ###########################
  #
  # FILE
  #
  # ::xo::scorm::File
  #
  ###########################


  Class File -superclass ::xoutil::File

  #::xowiki::File instmixin add ::xowiki::scorm::File

  File instproc get_cp_filename {} {
      set filename [my name]
      regsub -all "en:" $filename "" filename
      regsub -all "file:" $filename "" filename
      return $filename

  }

  # TODO This is dirty - use CR functions??
  File instproc write_to_file { {-path "/tmp"} } {
      file copy -force [acs_root_dir]/content-repository-content-files[my text] "$path/[my get_cp_filename]"
      return "$path/[my get_cp_filename]"
  }

}
